# mypy-boto3-lex-models

[![PyPI - mypy-boto3-lex-models](https://img.shields.io/pypi/v/mypy-boto3-lex-models.svg?color=blue)](https://pypi.org/project/mypy-boto3-lex-models)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-lex-models.svg?color=blue)](https://pypi.org/project/mypy-boto3-lex-models)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-lex-models](#mypy-boto3-lex-models)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.LexModelBuildingService 1.13.25](https://boto3.amazonaws.com/v1/documentation/api/1.13.25/reference/services/lex-models.html#LexModelBuildingService) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-lex-models](#mypy-boto3-lex-models)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `LexModelBuildingService` service.

```bash
python -m pip install boto3-stubs[lex-models]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_lex_models` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_lex_models import LexModelBuildingServiceClient

# Now mypy can check if your code is valid.
client: LexModelBuildingServiceClient = boto3.client("lex-models")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: LexModelBuildingServiceClient = session.client("lex-models")



# Annotated paginators are included as well

import mypy_boto3_lex_models.paginator as lex_models_paginators

get_bot_aliases_paginator: lex_models_paginators.GetBotAliasesPaginator = client.get_paginator("get_bot_aliases")
get_bot_channel_associations_paginator: lex_models_paginators.GetBotChannelAssociationsPaginator = client.get_paginator("get_bot_channel_associations")
get_bot_versions_paginator: lex_models_paginators.GetBotVersionsPaginator = client.get_paginator("get_bot_versions")
get_bots_paginator: lex_models_paginators.GetBotsPaginator = client.get_paginator("get_bots")
get_builtin_intents_paginator: lex_models_paginators.GetBuiltinIntentsPaginator = client.get_paginator("get_builtin_intents")
get_builtin_slot_types_paginator: lex_models_paginators.GetBuiltinSlotTypesPaginator = client.get_paginator("get_builtin_slot_types")
get_intent_versions_paginator: lex_models_paginators.GetIntentVersionsPaginator = client.get_paginator("get_intent_versions")
get_intents_paginator: lex_models_paginators.GetIntentsPaginator = client.get_paginator("get_intents")
get_slot_type_versions_paginator: lex_models_paginators.GetSlotTypeVersionsPaginator = client.get_paginator("get_slot_type_versions")
get_slot_types_paginator: lex_models_paginators.GetSlotTypesPaginator = client.get_paginator("get_slot_types")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_lex_models` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_lex_models as lex_models
from mypy_boto3_lex_models import LexModelBuildingServiceClient

# with these
from mypy_boto3 import lex_models
from mypy_boto3.lex_models import LexModelBuildingServiceClient
```